'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _Position = require('./Position');

var _Position2 = _interopRequireDefault(_Position);

var _Space = require('./Space');

var _Space2 = _interopRequireDefault(_Space);

var _unitsWarrior = require('./units/Warrior');

var _unitsWarrior2 = _interopRequireDefault(_unitsWarrior);

var Floor = (function () {
  function Floor() {
    _classCallCheck(this, Floor);

    this._width = 0;
    this._height = 0;
    this._stairsLocation = [-1, -1];
    this._units = [];
  }

  _createClass(Floor, [{
    key: 'getWidth',
    value: function getWidth() {
      return this._width;
    }
  }, {
    key: 'setWidth',
    value: function setWidth(width) {
      this._width = width;
    }
  }, {
    key: 'getHeight',
    value: function getHeight() {
      return this._height;
    }
  }, {
    key: 'setHeight',
    value: function setHeight(height) {
      this._height = height;
    }
  }, {
    key: 'getStairsLocation',
    value: function getStairsLocation() {
      return this._stairsLocation;
    }
  }, {
    key: 'getUnits',
    value: function getUnits() {
      return this._units.filter(function (unit) {
        return unit.getPosition();
      });
    }
  }, {
    key: 'getOtherUnits',
    value: function getOtherUnits() {
      return this.getUnits().filter(function (unit) {
        return !(unit instanceof _unitsWarrior2['default']);
      });
    }
  }, {
    key: 'getUniqueUnits',
    value: function getUniqueUnits() {
      var uniqueUnits = [];
      this.getUnits().forEach(function (unit) {
        if (!uniqueUnits.map(function (uniqueUnit) {
          return uniqueUnit.constructor;
        }).includes(unit.constructor)) {
          uniqueUnits.push(unit);
        }
      });

      return uniqueUnits;
    }
  }, {
    key: 'getSpaceAt',
    value: function getSpaceAt(x, y) {
      return new _Space2['default'](this, x, y);
    }
  }, {
    key: 'getUnitAt',
    value: function getUnitAt(x, y) {
      return this.getUnits().find(function (unit) {
        return unit.getPosition().isAt(x, y);
      });
    }
  }, {
    key: 'addUnit',
    value: function addUnit(unit, x, y, direction) {
      unit.setPosition(new _Position2['default'](this, x, y, direction));
      this._units.push(unit);
    }
  }, {
    key: 'placeStairs',
    value: function placeStairs(x, y) {
      this._stairsLocation = [x, y];
    }
  }, {
    key: 'getStairsSpace',
    value: function getStairsSpace() {
      return this.getSpaceAt.apply(this, _toConsumableArray(this.getStairsLocation()));
    }
  }, {
    key: 'isOutOfBounds',
    value: function isOutOfBounds(x, y) {
      return x < 0 || y < 0 || x > this._width - 1 || y > this._height - 1;
    }
  }, {
    key: 'toViewObject',
    value: function toViewObject() {
      return {
        width: this.getWidth(),
        height: this.getHeight(),
        units: this.getUnits().map(function (unit) {
          return unit.toViewObject();
        }),
        stairsLocation: this.getStairsLocation()
      };
    }
  }]);

  return Floor;
})();

exports['default'] = Floor;
module.exports = exports['default'];