'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _LevelLoader = require('./LevelLoader');

var _LevelLoader2 = _interopRequireDefault(_LevelLoader);

var _Logger = require('./Logger');

var _Logger2 = _interopRequireDefault(_Logger);

var MAX_TURNS = 1000;

var Level = (function () {
  function Level() {
    _classCallCheck(this, Level);

    this._warrior = null;
    this._floor = null;
    this._timeBonus = 0;
  }

  _createClass(Level, [{
    key: 'getWarrior',
    value: function getWarrior() {
      return this._warrior;
    }
  }, {
    key: 'setWarrior',
    value: function setWarrior(warrior) {
      this._warrior = warrior;
    }
  }, {
    key: 'getFloor',
    value: function getFloor() {
      return this._floor;
    }
  }, {
    key: 'setFloor',
    value: function setFloor(floor) {
      this._floor = floor;
    }
  }, {
    key: 'getTimeBonus',
    value: function getTimeBonus() {
      return this._timeBonus;
    }
  }, {
    key: 'setTimeBonus',
    value: function setTimeBonus(timeBonus) {
      this._timeBonus = timeBonus;
    }
  }, {
    key: 'getClearBonus',
    value: function getClearBonus() {
      if (!this.getFloor().getOtherUnits().length) {
        return Math.round((this.getWarrior().getScore() + this.getTimeBonus()) * 0.2);
      }

      return 0;
    }
  }, {
    key: 'loadLevel',
    value: function loadLevel(config, warrior) {
      new _LevelLoader2['default'](this).load(config, warrior);
    }
  }, {
    key: 'loadPlayer',
    value: function loadPlayer() {
      this.getWarrior().loadPlayer();
    }
  }, {
    key: 'passed',
    value: function passed() {
      return this.getFloor().getStairsSpace().isWarrior();
    }
  }, {
    key: 'failed',
    value: function failed() {
      return !this.getFloor().getUnits().includes(this.getWarrior());
    }
  }, {
    key: 'play',
    value: function play() {
      var turns = arguments.length <= 0 || arguments[0] === undefined ? MAX_TURNS : arguments[0];

      var trace = [];
      for (var n = 0; n < turns; n++) {
        if (this.passed() || this.failed()) break;

        var floor = this.getFloor().toViewObject();

        _Logger2['default'].clear();
        this.getFloor().getUnits().forEach(function (unit) {
          return unit.prepareTurn();
        });
        this.getFloor().getUnits().forEach(function (unit) {
          return unit.performTurn();
        });

        trace.push({
          floor: floor,
          log: _Logger2['default'].getLog(),
          turnNumber: n + 1
        });

        if (this.getTimeBonus()) this._timeBonus -= 1;
      }

      return {
        trace: trace,
        passed: this.passed(),
        points: {
          levelScore: this.getWarrior().getScore(),
          timeBonus: this.getTimeBonus(),
          clearBonus: this.getClearBonus()
        }
      };
    }
  }]);

  return Level;
})();

exports['default'] = Level;
module.exports = exports['default'];