'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _Floor = require('./Floor');

var _Floor2 = _interopRequireDefault(_Floor);

var _units = require('./units');

var _units2 = _interopRequireDefault(_units);

var _constantsUnitTypes = require('./constants/UnitTypes');

var _constantsUnitTypes2 = _interopRequireDefault(_constantsUnitTypes);

var LevelLoader = (function () {
  function LevelLoader(level) {
    _classCallCheck(this, LevelLoader);

    this._floor = new _Floor2['default']();

    this._level = level;
    this._level.setFloor(this._floor);
  }

  _createClass(LevelLoader, [{
    key: 'load',
    value: function load(config, warrior) {
      var _this = this;

      this._level.setTimeBonus(config.timeBonus);

      this._floor.setWidth(config.size.width);
      this._floor.setHeight(config.size.height);
      this._floor.placeStairs(config.stairs.x, config.stairs.y);

      var abilities = Object.assign({}, config.warrior.abilities, warrior.abilities);
      this.placeWarrior(warrior.name, warrior.playerCode, config.warrior.x, config.warrior.y, config.warrior.facing, abilities);
      config.units.forEach(function (unit) {
        return _this.placeUnit(unit.type, unit.x, unit.y, unit.facing, unit.abilities);
      });
    }
  }, {
    key: 'placeUnit',
    value: function placeUnit(type, x, y, facing) {
      var abilities = arguments.length <= 4 || arguments[4] === undefined ? {} : arguments[4];

      if (!_units2['default'].hasOwnProperty(type)) {
        throw new Error('Unknown unit \'' + type + '\'.');
      }

      var Unit = _units2['default'][type];

      var unit = new Unit();
      if (Object.keys(abilities).length) {
        unit.addAbilities(abilities);
      }

      this._floor.addUnit(unit, x, y, facing);
      return unit;
    }
  }, {
    key: 'placeWarrior',
    value: function placeWarrior(name, playerCode, x, y, facing, abilities) {
      var warrior = this.placeUnit(_constantsUnitTypes2['default'].warrior, x, y, facing, abilities);
      warrior.setName(name);
      warrior.setPlayerCode(playerCode);
      this._level.setWarrior(warrior);
    }
  }]);

  return LevelLoader;
})();

exports['default'] = LevelLoader;
module.exports = exports['default'];