'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _constantsDirections = require('./constants/Directions');

var _constantsDirections2 = _interopRequireDefault(_constantsDirections);

var _constantsRelativeDirections = require('./constants/RelativeDirections');

var _constantsRelativeDirections2 = _interopRequireDefault(_constantsRelativeDirections);

var DIRECTIONS = [_constantsDirections2['default'].north, _constantsDirections2['default'].east, _constantsDirections2['default'].south, _constantsDirections2['default'].west];

var RELATIVE_DIRECTIONS = [_constantsRelativeDirections2['default'].forward, _constantsRelativeDirections2['default'].right, _constantsRelativeDirections2['default'].backward, _constantsRelativeDirections2['default'].left];

var Position = (function () {
  function Position(floor, x, y) {
    var direction = arguments.length <= 3 || arguments[3] === undefined ? _constantsDirections2['default'].north : arguments[3];

    _classCallCheck(this, Position);

    this._floor = floor;
    this._x = x;
    this._y = y;
    this._directionIndex = DIRECTIONS.indexOf(direction);
  }

  _createClass(Position, [{
    key: 'getFloor',
    value: function getFloor() {
      return this._floor;
    }
  }, {
    key: 'getSpace',
    value: function getSpace() {
      return this.getFloor().getSpaceAt(this._x, this._y);
    }
  }, {
    key: 'getDirection',
    value: function getDirection() {
      return DIRECTIONS[this._directionIndex];
    }
  }, {
    key: 'isAt',
    value: function isAt(x, y) {
      return this._x === x && this._y === y;
    }
  }, {
    key: 'translateOffset',
    value: function translateOffset(forward, right) {
      var direction = this.getDirection();
      if (direction === _constantsDirections2['default'].north) {
        return [this._x + right, this._y - forward];
      } else if (direction === _constantsDirections2['default'].east) {
        return [this._x + forward, this._y + right];
      } else if (direction === _constantsDirections2['default'].south) {
        return [this._x - right, this._y + forward];
      } else if (direction === _constantsDirections2['default'].west) {
        return [this._x - forward, this._y - right];
      }
    }
  }, {
    key: 'move',
    value: function move(forward) {
      var right = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];

      var _translateOffset = this.translateOffset(forward, right);

      var _translateOffset2 = _slicedToArray(_translateOffset, 2);

      this._x = _translateOffset2[0];
      this._y = _translateOffset2[1];
    }
  }, {
    key: 'rotate',
    value: function rotate(amount) {
      this._directionIndex += amount;
      while (this._directionIndex > 3) this._directionIndex -= 4;
      while (this._directionIndex < 0) this._directionIndex += 4;
    }
  }, {
    key: 'getRelativeSpace',
    value: function getRelativeSpace(forward) {
      var right = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];

      var _translateOffset3 = this.translateOffset(forward, right);

      var _translateOffset32 = _slicedToArray(_translateOffset3, 2);

      var x = _translateOffset32[0];
      var y = _translateOffset32[1];

      return this.getFloor().getSpaceAt(x, y);
    }
  }, {
    key: 'getDistanceOf',
    value: function getDistanceOf(space) {
      var _space$getLocation = space.getLocation();

      var _space$getLocation2 = _slicedToArray(_space$getLocation, 2);

      var x = _space$getLocation2[0];
      var y = _space$getLocation2[1];

      return Math.abs(this._x - x) + Math.abs(this._y - y);
    }
  }, {
    key: 'getDistanceFromStairs',
    value: function getDistanceFromStairs() {
      return this.getDistanceOf(this.getFloor().getStairsSpace());
    }
  }, {
    key: 'getDirectionOf',
    value: function getDirectionOf(space) {
      var _space$getLocation3 = space.getLocation();

      var _space$getLocation32 = _slicedToArray(_space$getLocation3, 2);

      var x = _space$getLocation32[0];
      var y = _space$getLocation32[1];

      if (Math.abs(this._x - x) > Math.abs(this._y - y)) {
        return x > this._x ? _constantsDirections2['default'].east : _constantsDirections2['default'].west;
      }

      return y > this._y ? _constantsDirections2['default'].south : _constantsDirections2['default'].north;
    }
  }, {
    key: 'getRelativeDirection',
    value: function getRelativeDirection(direction) {
      var offset = DIRECTIONS.indexOf(direction) - this._directionIndex;
      while (offset > 3) offset -= 4;
      while (offset < 0) offset += 4;
      return RELATIVE_DIRECTIONS[offset];
    }
  }, {
    key: 'getRelativeDirectionOf',
    value: function getRelativeDirectionOf(space) {
      return this.getRelativeDirection(this.getDirectionOf(space));
    }
  }, {
    key: 'getRelativeDirectionOfStairs',
    value: function getRelativeDirectionOfStairs() {
      return this.getRelativeDirectionOf(this.getFloor().getStairsSpace());
    }
  }, {
    key: 'toViewObject',
    value: function toViewObject() {
      return {
        x: this._x,
        y: this._y,
        facing: this.getDirection()
      };
    }
  }]);

  return Position;
})();

exports['default'] = Position;
module.exports = exports['default'];