'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _unitsWarrior = require('./units/Warrior');

var _unitsWarrior2 = _interopRequireDefault(_unitsWarrior);

var ALLOWED_MEMBERS = ['isWall', 'isWarrior', 'isPlayer', 'isEnemy', 'isCaptive', 'isEmpty', 'isStairs', 'isTicking'];

var originalInstances = new WeakMap();

var Space = (function () {
  function Space(floor, x, y) {
    _classCallCheck(this, Space);

    this._floor = floor;
    this._x = x;
    this._y = y;
  }

  _createClass(Space, [{
    key: 'getLocation',
    value: function getLocation() {
      return [this._x, this._y];
    }
  }, {
    key: 'getUnit',
    value: function getUnit() {
      var _floor;

      return (_floor = this._floor).getUnitAt.apply(_floor, _toConsumableArray(this.getLocation()));
    }
  }, {
    key: 'isWall',
    value: function isWall() {
      var _floor2;

      return (_floor2 = this._floor).isOutOfBounds.apply(_floor2, _toConsumableArray(this.getLocation()));
    }
  }, {
    key: 'isWarrior',
    value: function isWarrior() {
      return this.getUnit() instanceof _unitsWarrior2['default'];
    }
  }, {
    key: 'isPlayer',
    value: function isPlayer() {
      return this.isWarrior();
    }
  }, {
    key: 'isEnemy',
    value: function isEnemy() {
      return this.getUnit() && !this.isPlayer() && !this.isCaptive();
    }
  }, {
    key: 'isCaptive',
    value: function isCaptive() {
      return this.getUnit() && this.getUnit().isBound();
    }
  }, {
    key: 'isEmpty',
    value: function isEmpty() {
      return !this.getUnit() && !this.isWall();
    }
  }, {
    key: 'isStairs',
    value: function isStairs() {
      var _floor$getStairsLocation = this._floor.getStairsLocation();

      var _floor$getStairsLocation2 = _slicedToArray(_floor$getStairsLocation, 2);

      var stairsX = _floor$getStairsLocation2[0];
      var stairsY = _floor$getStairsLocation2[1];

      var _getLocation = this.getLocation();

      var _getLocation2 = _slicedToArray(_getLocation, 2);

      var x = _getLocation2[0];
      var y = _getLocation2[1];

      return stairsX === x && stairsY === y;
    }
  }, {
    key: 'isTicking',
    value: function isTicking() {
      return this.getUnit() && this.getUnit().getAbilities().hasOwnProperty('explode');
    }
  }, {
    key: 'toString',
    value: function toString() {
      if (this.getUnit()) {
        return this.getUnit().toString();
      } else if (this.isWall()) {
        return 'wall';
      }

      return 'nothing';
    }

    /**
     * Make a new object that acts like a proxy of the Space, preventing the player
     * to access methods that don't belong to the Player API
     */
  }, {
    key: 'getPlayerObject',
    value: function getPlayerObject() {
      var _this = this;

      var allowedMembers = arguments.length <= 0 || arguments[0] === undefined ? ALLOWED_MEMBERS : arguments[0];

      var playerObject = {};

      // Add allowed members to the player object and bind them to the original instance
      allowedMembers.filter(function (id) {
        return typeof _this[id] === 'function';
      }).forEach(function (id) {
        return playerObject[id] = _this[id].bind(_this);
      });

      // Add a flag to the object indicating it is a proxy
      playerObject.isPlayerObject = true;

      // Reference the original instance to the player object
      originalInstances.set(playerObject, this);

      return playerObject;
    }
  }]);

  return Space;
})();

exports['default'] = Space;
exports.originalSpaces = originalInstances;