'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _abilitiesSensesSense = require('./abilities/senses/Sense');

var _abilitiesSensesSense2 = _interopRequireDefault(_abilitiesSensesSense);

var ALLOWED_MEMBERS = ['attack', 'bind', 'detonate', 'directionOf', 'directionOfStairs', 'distanceOf', 'explode', 'feel', 'health', 'listen', 'look', 'pivot', 'rescue', 'rest', 'shoot', 'walk'];

var Turn = (function () {
  function Turn(abilities) {
    var _this = this;

    _classCallCheck(this, Turn);

    this._action = null;
    this._senses = {};

    Object.entries(abilities).forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2);

      var name = _ref2[0];
      var ability = _ref2[1];

      if (ability instanceof _abilitiesSensesSense2['default']) {
        _this.addSense(name, ability);
      } else {
        _this.addAction(name);
      }
    });
  }

  _createClass(Turn, [{
    key: 'getAction',
    value: function getAction() {
      return this._action;
    }
  }, {
    key: 'addAction',
    value: function addAction(name) {
      var _this2 = this;

      Object.defineProperty(this, name, {
        value: function value() {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          if (_this2._action) {
            throw new Error('Only one action can be performed per turn.');
          }

          _this2._action = [name, args];
        }
      });
    }
  }, {
    key: 'addSense',
    value: function addSense(name, sense) {
      var _this3 = this;

      this._senses[name] = sense;
      Object.defineProperty(this, name, {
        value: function value() {
          var _senses$name;

          return (_senses$name = _this3._senses[name]).perform.apply(_senses$name, arguments);
        }
      });
    }

    /**
     * Make a new object that acts like a proxy of the Turn, preventing the player
     * to access methods that don't belong to the Player API
     */
  }, {
    key: 'getPlayerObject',
    value: function getPlayerObject() {
      var _this4 = this;

      var allowedMembers = arguments.length <= 0 || arguments[0] === undefined ? ALLOWED_MEMBERS : arguments[0];

      var playerObject = {};

      // Add allowed members to the player object and bind them to the original instance
      allowedMembers.filter(function (id) {
        return typeof _this4[id] === 'function';
      }).forEach(function (id) {
        return playerObject[id] = _this4[id].bind(_this4);
      });

      // Add a flag to the object indicating it is a proxy
      playerObject.isPlayerObject = true;

      return playerObject;
    }
  }]);

  return Turn;
})();

exports['default'] = Turn;
module.exports = exports['default'];