'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var _bind = Function.prototype.bind;

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _Turn = require('../Turn');

var _Turn2 = _interopRequireDefault(_Turn);

var _Logger = require('../Logger');

var _Logger2 = _interopRequireDefault(_Logger);

var _abilities = require('../abilities');

var _abilities2 = _interopRequireDefault(_abilities);

var Unit = (function () {
  function Unit() {
    _classCallCheck(this, Unit);

    this._name = 'Unit';
    this._type = null;
    this._position = null;
    this._attackPower = 0;
    this._shootPower = 0;
    this._maxHealth = 0;
    this._health = null;
    this._abilities = {};
    this._currentTurn = null;
  }

  _createClass(Unit, [{
    key: 'getName',
    value: function getName() {
      return this._name;
    }
  }, {
    key: 'getType',
    value: function getType() {
      return this._type;
    }
  }, {
    key: 'getPosition',
    value: function getPosition() {
      return this._position;
    }
  }, {
    key: 'setPosition',
    value: function setPosition(position) {
      this._position = position;
    }
  }, {
    key: 'getAttackPower',
    value: function getAttackPower() {
      return this._attackPower;
    }
  }, {
    key: 'getShootPower',
    value: function getShootPower() {
      return this._shootPower;
    }
  }, {
    key: 'getMaxHealth',
    value: function getMaxHealth() {
      return this._maxHealth;
    }
  }, {
    key: 'getHealth',
    value: function getHealth() {
      this._health = this._health !== null ? this._health : this.getMaxHealth();
      return this._health;
    }
  }, {
    key: 'setHealth',
    value: function setHealth(health) {
      this._health = health;
    }
  }, {
    key: 'getAbilities',
    value: function getAbilities() {
      return this._abilities;
    }
  }, {
    key: 'isAlive',
    value: function isAlive() {
      return this.getPosition() !== null;
    }
  }, {
    key: 'isBound',
    value: function isBound() {
      return this._bound;
    }
  }, {
    key: 'unbind',
    value: function unbind() {
      this._bound = false;
      this.say('released from bonds');
    }
  }, {
    key: 'bind',
    value: function bind() {
      this._bound = true;
    }
  }, {
    key: 'say',
    value: function say(message) {
      _Logger2['default'].log(this.getType(), this.getName() + ' ' + message);
    }
  }, {
    key: 'takeDamage',
    value: function takeDamage(amount) {
      if (this.isBound()) {
        this.unbind();
      }

      if (this.getHealth()) {
        var revisedAmount = this.getHealth() - amount < 0 ? this.getHealth() : amount;
        this._health -= revisedAmount;
        this.say('takes ' + amount + ' damage, ' + this.getHealth() + ' health power left');
        if (!this.getHealth()) {
          this.setPosition(null);
          this.say('dies');
        }
      }
    }
  }, {
    key: 'addAbilities',
    value: function addAbilities(newAbilities) {
      var _this = this;

      Object.entries(newAbilities).forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2);

        var name = _ref2[0];
        var args = _ref2[1];

        if (!_abilities2['default'].hasOwnProperty(name)) {
          throw new Error('Unknown ability \'' + name + '\'.');
        }

        var Ability = _abilities2['default'][name];
        _this._abilities[name] = new (_bind.apply(Ability, [null].concat([_this], _toConsumableArray(args))))();
      });
    }
  }, {
    key: 'getNextTurn',
    value: function getNextTurn() {
      return new _Turn2['default'](this.getAbilities());
    }
  }, {
    key: 'playTurn',
    value: function playTurn(turn) {// eslint-disable-line no-unused-vars
      // To be overriden by subclass
    }
  }, {
    key: 'prepareTurn',
    value: function prepareTurn() {
      this._currentTurn = this.getNextTurn();
      this.playTurn(this._currentTurn);
    }
  }, {
    key: 'performTurn',
    value: function performTurn() {
      if (this.getPosition()) {
        Object.values(this.getAbilities()).forEach(function (ability) {
          return ability.passTurn();
        });
        if (this._currentTurn.getAction() && !this.isBound()) {
          var _getAbilities$_name;

          var _currentTurn$getAction = this._currentTurn.getAction();

          var _currentTurn$getAction2 = _slicedToArray(_currentTurn$getAction, 2);

          var _name = _currentTurn$getAction2[0];
          var args = _currentTurn$getAction2[1];

          (_getAbilities$_name = this.getAbilities()[_name]).perform.apply(_getAbilities$_name, _toConsumableArray(args));
        }
      }
    }
  }, {
    key: 'earnPoints',
    value: function earnPoints(points) {// eslint-disable-line no-unused-vars
      // To be overriden by subclass
    }
  }, {
    key: 'toViewObject',
    value: function toViewObject() {
      return {
        name: this.getName(),
        type: this.getType(),
        position: this.getPosition().toViewObject()
      };
    }
  }, {
    key: 'toString',
    value: function toString() {
      return this.getName();
    }
  }]);

  return Unit;
})();

exports['default'] = Unit;
module.exports = exports['default'];